#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include <math.h>

#include "syre.h"

int dev_dsp;

void open_dev_dsp(void)
{
   
      int frequency, stereo, samplesize;
   
      int numfrags, fragsize, fragmentsize;
   
      if(!(dev_dsp = open("/dev/dsp", O_WRONLY | O_NDELAY, 0))) {
	 
	       fprintf(stdout, "Unable to open /dev/dsp\n");
	       exit(1);
      }
      
   
      samplesize = PLAYBACK_BITRATE;
      if( ioctl( dev_dsp, SNDCTL_DSP_SAMPLESIZE, &samplesize ) == -1 ) {
	 
	       fprintf( stderr, "Unable to set sample size!\n");
	       exit(1);
      }
   
   
      stereo = 1;
      if( ioctl( dev_dsp, SNDCTL_DSP_STEREO, &stereo ) == -1 ) {
	 
	       fprintf( stderr, "Unable to set stereo playback!\n");
	       exit(1);
      }
   
   
      frequency = PLAYBACK_FREQ;
      if( ioctl( dev_dsp, SNDCTL_DSP_SPEED, &frequency ) == -1 ) {
	 
	       fprintf( stderr, "Unable to set playback frequency!\n");
	       exit(1);
      }
   
   
      numfrags = 64;
      fragsize = 17;
   
      fragmentsize = (numfrags << 16) | fragsize;
      if( ioctl( dev_dsp, SNDCTL_DSP_SETFRAGMENT, &fragmentsize) == -1) {
	 
	       fprintf( stderr, "Unable to set buffer fragment!\n");
	       exit(1);
      }
   
   
   
      /*
       *    if( ioctl( dev_dsp, SNDCTL_DSP_SYNC, 0 ) == -1 ) {
	  
	        fprintf( stderr, "Unable to sync dma!\n");
	        exit(1);
       }
       * 
       *    */
   
   
}


void close_dev_dsp(void)
{
   
      close(dev_dsp);
}
